import json
import time
import redis
from bs4 import BeautifulSoup
from fastapi import Body, Depends, APIRouter, Query
import asyncio
import random
import re
from pydantic import BaseModel, Field
from utils.ptools import redis_host
from utils.ptools import fs_send_msg, cookies, format_value, clean_html, clean_title,put_logs,get_re_content,get_redis_proxies
from loguru import logger
import aiohttp

readable_characters_pattern = re.compile(r'[\u4e00-\u9fffa-zA-Z0-9]')

tunnel = "y813.kdltps.com:15818"
username = "t12405069432210"
password = "boetpl6x"
proxy_auth = aiohttp.BasicAuth(username, password)


dm_tunnel = '58.241.101.70:10381'
# 用户名密码认证(私密代理/独享代理)
username = "GplQoKSu"
password = "CvvpTesQ"
dm_proxy_auth = aiohttp.BasicAuth(username, password)


async def fetch(session, url):
    async with session.get(url, proxy="http://" + random.choice(proxy_list), proxy_auth=proxy_auth) as resp:
        content = await resp.read()


proxyHost = "http-dyn.abuyun.com"
proxyPort = "9020"
# 代理隧道验证信息
proxyUser = "HUGE9Q7E68J43M2D"
proxyPass = "9D73B37F9FC7A688"

proxyMeta = "http://%(user)s:%(pass)s@%(host)s:%(port)s" % {
    "host": proxyHost,
    "port": proxyPort,
    "user": proxyUser,
    "pass": proxyPass,
}

headers = {
    'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.7',
    'Accept-Language': 'zh-CN,zh;q=0.9',
    'Cache-Control': 'max-age=0',
    'Connection': 'close',
    'Sec-Fetch-Dest': 'document',
    'Sec-Fetch-Mode': 'navigate',
    'Sec-Fetch-Site': 'none',
    'Sec-Fetch-User': '?1',
    'Upgrade-Insecure-Requests': '1',
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/126.0.0.0 Safari/537.36',
    'sec-ch-ua': '"Not/A)Brand";v="8", "Chromium";v="126", "Google Chrome";v="126"',
    'sec-ch-ua-mobile': '?0',
    'sec-ch-ua-platform': '"macOS"',
}


async def fetch_url(url, timeout, require_redis, max_retries=1, cookies_bool=False, check_value=None):
    if require_redis:
        redis_conn = redis.Redis(host=redis_host, port=6379, db=10, socket_timeout=1)
        key_value = redis_conn.get(url)
        if key_value:
            if key_value.decode() == "None":
                return None
            return key_value.decode()
        redis_conn.close()
    retries = 0
    while retries < max_retries:
        try:
            conn = aiohttp.TCPConnector(ssl=False)
            async_timeout = aiohttp.ClientTimeout(total=timeout)
            async with aiohttp.ClientSession(headers=headers, connector=conn) as session:
                proxy = get_redis_proxies()
                async with session.get(url, timeout=async_timeout, proxy=proxy) as response:
                    rex_text = await response.text()
                    if check_value and check_value not in rex_text:
                        raise Exception(f"check_value 不存在== {check_value}")
                    if require_redis:
                        redis_conn = redis.Redis(host=redis_host, port=6379, db=10, socket_timeout=1)
                        redis_conn.setex(url, 60*60*24*1, rex_text)  # 设置过期时间为 60 秒
                        redis_conn.close()
                    return rex_text

        except asyncio.TimeoutError as e:
            retries += 1
            logger.error(f'error== 请求超时错误 timeout={timeout}：Retry {retries} for {url} -- {e}')
        except aiohttp.ClientError as e:
            retries += 1
            logger.error(f'error== 客户端请求错误 timeout={timeout}：Retry {retries} for {url} -- {e}')
        except Exception as e:
            retries += 1
            logger.error(f'error== 请求未知错误 timeout={timeout}：Retry {retries} for {url} -- {e}')
    if require_redis:
        redis_conn.setex(url, 60 * 60 * 24 * 1, "None")
        redis_conn.close()
    return None


def get_table_bool(soup):
    tables = soup.find_all('table')
    text_table_found = False
    # 遍历每个表格元素，检查是否包含文本内容
    for table in tables:
        if any(cell.get_text(strip=True) for cell in table.find_all(['td', 'th'])):
            text_table_found = True
            break
    return text_table_found


def get_content(response):
    re_par = ['div.content'                    # 中华人民共和国中央人民政府  https://www.gov.cn/xinwen/2019-05/22/content_5393689.htm
              'div.index_cententWrap__Jv8jK',  # 澎湃新闻
              'div.content-article',           # 腾讯新闻  https://new.qq.com/rain/a/20240521A0A1VC00
              'div.content_18313',             # 央视网    https://news.cctv.com/2024/06/25/ARTIrfDXpIwhQw0wnnVb7nex240625.shtml
              'div#detail',                    # 新华网    http://www.news.cn/20240627/e001bbf63cf14cc3a7d49941c37d5670/c.html
              'div.text_c',                    # 中国共产党新闻网 'http://cpc.people.com.cn/
              '#mp-editor', 'article.article-text', 'div.article-content-wrapper']
    re_par_str = ", ".join(re_par)
    selected_element = response.select_one(re_par_str)
    if selected_element:
        content_text = clean_html(selected_element.get_text())
    else:
        content_text = None
    return content_text

def readable_ratio(text: str) -> float:
    """
    可读字符的占比
    """
    if text:
        readable_characters = readable_characters_pattern.findall(text)
        return len(readable_characters) / len(text)
    return 0.0


async def main_query(detail_urls, timeout, require_html, require_content, require_image, require_redis):
    item_list = []
    tasks = [fetch_url(url, timeout, require_redis) for url in detail_urls]
    results = await asyncio.gather(*tasks)
    error_count = 0

    for index, result in enumerate(results):
        imgs_list = []
        old_text = None
        title, has_table, content, html, status = None, None, None, None, -1
        content_status = 0
        if result:
            tilte_ = re.findall(r'<title(?:\s+\S+=".*?")*>(.*?)</title>', result, re.DOTALL)
            if tilte_:
                title = clean_title(format_value(tilte_[0]))
            soup = BeautifulSoup(result, "lxml")
            has_table = get_table_bool(soup)
            if require_content:
                content = get_content(soup)
                content_status = 1
                if not content or len(content) < 128:
                    content = get_re_content(detail_urls[index], result)
                    content_status = 1.5
                if not content:
                    content = clean_html(soup.get_text())
                    content_status = 2

                if not content:
                    content = None
                    content_status = 3
            if require_html:
                html = result
            if require_image:
                img_tags = soup.find_all('img')
                for img_one in img_tags:
                    img = img_one.get('src')
                    # pass_bool = re.findall(r'jpg|jpeg|png|gif|bmp|PNG|JPG|JEPG|GIF', img)
                    # if pass_bool:
                    if img:
                        if img.startswith('//'):
                            img = "https:" + img
                        if img.startswith('http') and "icon" not in img and "logo" not in img:
                            img = img.strip()
                            imgs_list.append(img)

        title_false = ["百度安全验证", "403Forbidden", "502BadGateway"]
        if title in title_false:
            title, content, html = None, None, None
            content_status = 4

        if content:
            type_num = readable_ratio(content)
            if type_num < 0.3:
                old_text = content
                title, content, html = None, None, None
                content_status = 5

            elif len(format_value(content)) < 128:
                content_status = 6
                old_text = content
                contents = [
                    ('log_type', "warning"),
                    ('time', ''),
                    ('query', detail_urls[index]),
                    ('api_type', 'bing_detail'),
                    ('msg', f"{detail_urls[index]} --- {content}"),
                    ('remark', 'url解析content失败'),
                    ('response', result),
                ]

                put_logs(contents)
                title, content, html = None, None, None
        if not imgs_list:
             imgs_list = None
        else:
            imgs_list = list(set(imgs_list))
        item = {
            'url': detail_urls[index],
            'title': title,
            'has_table': has_table,
            'content_status': content_status,
            'text': content,
            'old_text': old_text,
            'imgs_list': imgs_list,
            'html': html,
        }
        if content_status == 0 or content_status > 2:
            error_count += 1
        item_list.append(item)

    logger.info(f'info==3 成功获取item_list 共 {len(item_list)} 条数据')
    return item_list, error_count

# 定义路由
bingDetailRedis_router = APIRouter()


class FindGDListRequest(BaseModel):
    timeout: int = 3
    require_content: bool = True
    require_html: bool = False
    require_image: bool = False
    require_redis: bool = True
    url_list: list = Field(None, title="企业list", max_length=300)


@bingDetailRedis_router.post(
    "/chain/aiSearch/bingDetailQueryRedis",
    summary="bing_detail_redis引擎搜索",
    response_description='''
    {
        "timeout": 3,  
        "require_content": true,
        "require_html": false,
        "require_image": false,
        "require_redis": true,
        "url_list": [
                        "https://news.sina.com.cn/w/2024-05-31/doc-inaxakrn0879057.shtml",
                        "https://news.sina.com.cn/o/2024-05-16/doc-inavmmfk8753043.shtml",
                        "https://www.thepaper.cn/newsDetail_forward_27864911",
                        "https://www.thepaper.cn/newsDetail_forward_27574452",
                        "https://www.thepaper.cn/newsDetail_forward_22585273",
                        "http://www.news.cn/world/20240626/b69179d44c364e468e4503d6ecd51045/c.html",
                        "https://baike.baidu.com/item/%E5%94%90%E7%B4%8D%E5%BE%B7%C2%B7%E7%89%B9%E6%9C%97%E6%99%AE/9916449",
                        "https://chinese.aljazeera.net/news/political/2023/6/10/%e7%be%8e%e5%9b%bd%e6%80%bb%e7%bb%9f%e5%8f%b2%e4%b8%8a%e5%85%88%e4%be%8b%e7%89%b9%e6%9c%97%e6%99%ae%e9%9d%a2%e4%b8%b437%e9%a1%b9%e6%8c%87%e6%8e%a7",
                        "https://news.cctv.com/2024/06/27/ARTICqwUFMadeJyqls83aeA0240627.shtml",
                        "https://www.thepaper.cn/newsDetail_forward_1568668",
                        "https://www.thepaper.cn/newsDetail_forward_27574452"
        ]      
    }
    '''
)
async def find_sg_selective(
        request: FindGDListRequest = Body(None, title="传入参数")
):
    '''
    bing 提交列表url查询content html搜索结果(post)
    '''
    start_date = time.time()
    url_list = request.url_list
    timeout = request.timeout
    require_html = request.require_html
    require_content = request.require_content
    require_redis = request.require_redis
    require_image = request.require_image
    try:
        sq_list, error_count = await main_query(url_list, timeout, require_html, require_content, require_image, require_redis)
        end_date = time.time()
        data = {"status": 200,
                "message": "查询成功",
                'time': "{:.2f}".format(end_date - start_date),
                'warn_count': error_count, 'data': sq_list}
        contents = [
            ('log_type', "success"),
            ('time', ''),
            ('query', json.dumps(url_list, ensure_ascii=False)),
            ('api_type', 'bing_detail_redis'),
            ('msg', ""),
            ('remark', 'url_list获取网页成功'),
            ('response', json.dumps(data, ensure_ascii=False)),
        ]
        put_logs(contents)
    except Exception as e:
        end_date = time.time()
        data = {"status": 0,
                "message": "查询失败，请联系管理员",
                'time': "{:.2f}".format(end_date - start_date),
                'warn_count': 0, 'data': []}
        fs_send_msg("error", "bing_detail_redis", f"搜索{timeout}, {require_html}, {require_content}, {require_redis} ,{url_list} 异常报错 {e}")
        contents = [
            ('log_type', "error"),
            ('time', ''),
            ('query', json.dumps(url_list, ensure_ascii=False)),
            ('api_type', 'bing_detail_redis'),
            ('msg', f"搜索{timeout}, {require_html}, {require_content} url_list 异常报错 {e}"),
            ('remark', 'url_list获取网页失败'),
            ('response', json.dumps(data, ensure_ascii=False)),
        ]
        put_logs(contents)
    return data



