import json
import time
from io import BytesIO

import oss2
import redis
from PIL import Image
from fastapi import Body, Depends, APIRouter, Query
import asyncio
import random
import re
from pydantic import BaseModel, Field
from utils.ptools import fs_send_msg, cookies, format_value, clean_html, clean_title, put_logs, get_re_content, \
    generate_md5, redis_host,upload_image
from loguru import logger
import aiohttp

readable_characters_pattern = re.compile(r'[\u4e00-\u9fffa-zA-Z0-9]')

proxy_list = [
    "117.33.148.180:16817"
]
# 用户名密码认证(私密代理/独享代理)
username = "ohimbkvo"
password = "tz4iya07"
proxy_auth = aiohttp.BasicAuth(username, password)


async def fetch(session, url):
    async with session.get(url, proxy="http://" + random.choice(proxy_list), proxy_auth=proxy_auth) as resp:
        content = await resp.read()


proxyHost = "http-dyn.abuyun.com"
proxyPort = "9020"
# 代理隧道验证信息
proxyUser = "HUGE9Q7E68J43M2D"
proxyPass = "9D73B37F9FC7A688"

proxyMeta = "http://%(user)s:%(pass)s@%(host)s:%(port)s" % {
    "host": proxyHost,
    "port": proxyPort,
    "user": proxyUser,
    "pass": proxyPass,
}

headers = {
    'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.7',
    'Accept-Language': 'zh-CN,zh;q=0.9',
    'Cache-Control': 'max-age=0',
    'Connection': 'close',
    'Sec-Fetch-Dest': 'document',
    'Sec-Fetch-Mode': 'navigate',
    'Sec-Fetch-Site': 'none',
    'Sec-Fetch-User': '?1',
    'Upgrade-Insecure-Requests': '1',
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/126.0.0.0 Safari/537.36',
    'sec-ch-ua': '"Not/A)Brand";v="8", "Chromium";v="126", "Google Chrome";v="126"',
    'sec-ch-ua-mobile': '?0',
    'sec-ch-ua-platform': '"macOS"',
}




async def main_query(icon_list, timeout, require_redis, require_filter):
    redis_image_items = {}
    icon_list_yes = icon_list
    icon_list_no = []
    if require_redis:
        redis_conn = redis.Redis(host=redis_host, port=6379, db=6, socket_timeout=1)
        for url in icon_list:
            key_value = redis_conn.get(url)
            if key_value:
                new_item = json.loads(key_value)
                redis_image_items[url] = new_item
                icon_list_no.append(url)
        redis_conn.close()
    icon_list_con = [x for x in icon_list_yes if x not in icon_list_no]

    if len(icon_list_con) > 0:
        no_redis_image_items, error_count = await upload_image(icon_list_con, timeout)
        image_items = {**redis_image_items, **no_redis_image_items}
    else:
        image_items = redis_image_items
    if require_redis:
        redis_conn = redis.Redis(host=redis_host, port=6379, db=6, socket_timeout=1)
        for url in image_items:
            url_values = image_items[url]
            redis_conn.setex(url, 60 * 60 * 24, json.dumps(url_values, ensure_ascii=False))
    error_count = 0
    if require_filter:
        for one in list(image_items.keys()):
            one_value = image_items[one]
            width = one_value['width']
            height = one_value['height']
            if width and height:
                if width > 400 and height > 400:
                    pass
                else:
                    del image_items[one]
            else:
                error_count += 1
                del image_items[one]

    logger.info(f'info== icon {len(icon_list)} 张，下载完成，返回数据 {len(image_items)} 条')
    logger.info(f'info==3 成功获取item_list 共 {len(image_items)} 条数据')
    return image_items, error_count


# 定义路由
bingImageRedis_router = APIRouter()


class FindGDListRequest(BaseModel):
    timeout: int = 1
    require_redis: bool = True
    require_filter: bool = False
    url_list: list = Field(None, title="企业list", max_length=300)


@bingImageRedis_router.post(
    "/chain/aiSearch/bingImageDownRedis",
    summary="图片缓存下载",
    response_description='''
    {
        "timeout": 1, 
        "require_redis": true,
        "require_filter": false,
        "url_list": [
                "https://ts2.cn.mm.bing.net/th?id=ODLS.65b82400-adc8-4210-a736-dc13e4a7dbf6",
                "https://ts1.cn.mm.bing.net/th?id=ODLS.92f5319d-76e3-47b3-8f06-32644b673f89",
                "https://ts1.cn.mm.bing.net/th?id=ODLS.ff682bac-bda7-407a-98c3-7dd6224c2f56",
                "https://ts4.cn.mm.bing.net/th?id=ODLS.36d073ae-c09f-493d-b480-6eff2b491896",
                "https://ts1.cn.mm.bing.net/th?id=ODLS.5cf5a999-7b89-4e15-bcb1-7d41fdaa2f9e",
                "https://ts2.cn.mm.bing.net/th?id=ODLS.65b82400-adc8-4210-a736-dc13e4a7dbf6",
                "https://imagecloud.thepaper.cn/thepaper/image/307/479/207.jpg",
                "https://n.sinaimg.cn/news/transform/299/w180h119/20201019/1d08-kaqzmiw7450166.png"
        ]      
    }
    '''
)
async def find_sg_selective(
        request: FindGDListRequest = Body(None, title="传入参数")
):
    '''
    bing 提交列表url获取oss_url图片下载地址(post)
    '''
    start_date = time.time()
    url_list = request.url_list
    if url_list:
        url_list = list(set(url_list))
    require_redis = request.require_redis
    require_filter = request.require_filter
    timeout = request.timeout
    try:
        sq_list, error_count = await main_query(url_list, timeout, require_redis, require_filter)
        end_date = time.time()
        data = {"status": 200,
                "message": "查询成功",
                'time': "{:.2f}".format(end_date - start_date),
                'in_count': len(url_list),
                'out_count': len(sq_list),
                'warn_count': error_count, 'data': sq_list}
        contents = [
            ('log_type', "success"),
            ('time', ''),
            ('query', json.dumps(url_list, ensure_ascii=False)),
            ('api_type', 'bing_image_redis'),
            ('msg', ""),
            ('remark', 'url_list获取网页成功'),
            ('response', json.dumps(data, ensure_ascii=False)),
        ]
        put_logs(contents)
    except Exception as e:
        end_date = time.time()
        data = {"status": 0,
                "message": "查询失败，请联系管理员",
                'time': "{:.2f}".format(end_date - start_date),
                'warn_count': 0, 'data': []}
        fs_send_msg("error", "bing_image_redis", f"搜索timeout={timeout}, url_list={url_list}  异常报错 {e}")
        contents = [
            ('log_type', "error"),
            ('time', ''),
            ('query', json.dumps(url_list, ensure_ascii=False)),
            ('api_type', 'bing_image_redis'),
            ('msg', f"搜索timeout={timeout}, url_list={url_list}  异常报错 {e}"),
            ('remark', 'url_list获取网页失败'),
            ('response', json.dumps(data, ensure_ascii=False)),
        ]
        put_logs(contents)
    return data


# async def run():
#     url_list = ["https://tse1-mm.cn.bing.net/th?id=OIP.otKgF7eVJduviIgp6ZHGGQDIDI&pid=15.1"]
#     a, b = await upload_image(url_list, 2)
#     print(a, b)
#
#
# if __name__ == '__main__':
#     asyncio.run(run())
