from fastapi import FastAPI

from course.bing_list import bingList_router
from course.bing_detail_redis import bingDetailRedis_router
from course.bing_image_redis import bingImageRedis_router
from course.bing_images_query import bingImageQuery_router
from fastapi.middleware.gzip import GZipMiddleware

from apscheduler.schedulers.background import BackgroundScheduler
scheduler = BackgroundScheduler()

app = FastAPI()
app.add_middleware(GZipMiddleware, minimum_size=1000)

app.include_router(bingList_router)
app.include_router(bingDetailRedis_router)
# app.include_router(bingImageRedis_router)
# app.include_router(bingImageQuery_router)


