import asyncio
import hashlib
import json
import re
import time
import unicodedata
from io import BytesIO
import aiohttp
import oss2
from PIL import Image
from bs4 import BeautifulSoup
from loguru import logger

placeholder = '%s'
maxlimit = -1

# 这里改成自己的redis
# redis_host = 'r-bp1jxndjwzf1lrgndb.redis.rds.aliyuncs.com'  # 专用网络
redis_host = "127.0.0.1"
# 这里改成自己的oss配置
oss_key = 'LTAI5tCk5dyxAFbu4osESe1b'
oss_value = 'VdLysdFG1pjHu9U7bTuLCZx0lQFLbb'

proxies_bool = True

false_url = ['chinese.aljazeera.net', 'aibook.ren', 'datawhalechina.github.io',
             'bilibili.com', 'www.qidian.com', 'm.qidian.com', 'zs.chinamae.com',
             'jsggzy.jszwfw.gov.cn', 'ggzy.zj.gov.cn', 'zjpubservice.zjzwfw.gov.cn',
             'www.zjpy.gov.cn', 'm.21jingji.com', 'www.chinairr.org', 'www.huaon.com',
             'news.jingji.net', 'liveuamap.com', 'www.bbc.com',
             'www.jianyu360.cn', 'www.biaozhaozhao.com',
             'www.tianyancha.com', 'www.qcc.com', 'www.yfbzb.com', 'www.qixin.com', 'baidu.com',
             'www.zhihu.com', 'www.bidcenter.com.cn', 'www.gov.cn', 'www.cbi360.net', 'api.huangye88.com'
             ]


def escape(string):
    return '`%s`' % string


def format_string(s):
    return s.replace('%', '%%')


def generate_md5(string):  # 字符串转md5
    m = hashlib.md5()
    m.update(string.encode('utf-8'))
    return m.hexdigest()


def fs_send_msg(level, spider, msg):
    print(f"level={level} spider={spider} msg={msg}")


cookies = {
    "SRCHHPGUSR": "SRCHLANG=zh-Hans&BZA=0&HV=1719911300&BRW=W&BRH=S&CW=1405&CH=150&SCW=1405&SCH=2032&DPR=2.0&UTC=480&DM=0&PV=14.2.1&WTS=63855508093"
}


def get_cookies():
    HV = int(time.time())
    cookies_ = {
        "SRCHHPGUSR": f"SRCHLANG=zh-Hans&PV=14.2.1&BZA=0&HV={HV}&BRW=W&BRH=S&CW=1456&CH=269&SCW=1456&SCH=1912&DPR=2.0&UTC=480&DM=0&WTS=63855395623"
    }
    return cookies_


def format_value(value):
    """
    只针对字符串的格式化
    :param value:
    :return:
    """
    if value:
        value = re.sub("\r|\n|\t|\\u3000|\\xa0|\\u00A0|\u0001|\u0001|\u0001|\u0001|\u0001\D｜\\u0001|\s|\ue000|\ue001",
                       "", str(value).strip())
        return value
    return ""


def get_domain(originalurl):
    pattern = r"(?<=://)(.*?)(?=/)"
    try:
        domain = re.search(pattern, originalurl).group()
        return domain
    except Exception:
        return ''


def get_unicode_whitespace_chars():
    unicode_chars = (chr(i) for i in range(0x110000))
    whitespace_chars = [char for char in unicode_chars if unicodedata.category(char) == 'Zs' or char.isspace()]
    return whitespace_chars


whitespace_char_list = get_unicode_whitespace_chars()
continuous_lf = re.compile(r'\n+')
continuous_whitespace = re.compile(f'[{re.escape("".join(whitespace_char_list))}\t]+')


# def clean_html(result) -> str:
#     result = continuous_lf.sub('\n', result)
#     result = continuous_whitespace.sub(' ', result)
#     return result.strip()

def clean_html(result) -> str:
    result = re.sub(r'\r', '\n', result)
    result = re.sub(r'\t', '\n', result)
    result = re.sub(r'\n+', '这里是空格', result)
    result = re.sub(r'\s+', ' ', result)
    result = result.replace('这里是空格 ', '这里是空格')
    result = re.sub(r'这里是空格', '\n', result)
    result = re.sub(r'\n+', '\n', result)
    result = result.strip().strip('\n')
    return result


def clean_title(title):
    if title:
        title = title.replace('&nbsp;', "").replace('<br>', "").replace('</br>', "").replace("&quot;", "")
    return title


# 日志服务的服务接入点。此处以杭州为例，其它地域请根据实际情况填写。
def put_logs(contents):
    log_group = []
    # contents = [
    #         ('log_type', "{'text':'massage'}"),
    #         ('time', 'level'),
    #         ('api_type', 'level'),
    #         ('msg', 'level'),
    #         ('remark', 'level'),
    #         ('response', 'level'),
    #         ('query', 'level'),
    #     ]
    # log_item = LogItem()
    # log_item.set_contents(contents)
    # log_group.append(log_item)
    # request = PutLogsRequest(project_name, logstore_name, "", "", log_group, compress=False)
    # client.put_logs(request)
    print("put contents  success  %s " % contents)


def get_re_content(url, response):
    try:
        if "new.qq.com/rain" in url:
            window_data = re.findall(r'window.DATA = (\{.*?});', response, flags=re.DOTALL)
            data = json.loads(window_data[0])
            desc = data['originContent']['text']
            soup = BeautifulSoup(desc, "lxml")
            return soup.get_text()
        else:
            return None
    except Exception as e:
        return None


headers = {
    'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.7',
    'Accept-Language': 'zh-CN,zh;q=0.9',
    'Cache-Control': 'max-age=0',
    'Connection': 'close',
    'Sec-Fetch-Dest': 'document',
    'Sec-Fetch-Mode': 'navigate',
    'Sec-Fetch-Site': 'none',
    'Sec-Fetch-User': '?1',
    'Upgrade-Insecure-Requests': '1',
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/126.0.0.0 Safari/537.36',
    'sec-ch-ua': '"Not/A)Brand";v="8", "Chromium";v="126", "Google Chrome";v="126"',
    'sec-ch-ua-mobile': '?0',
    'sec-ch-ua-platform': '"macOS"',
}


async def fetch_url(url, timeout, max_retries=1, cookies_bool=False, check_value=None):
    retries = 0
    while retries < max_retries:
        try:
            conn = aiohttp.TCPConnector(ssl=False)
            async_timeout = aiohttp.ClientTimeout(total=timeout)
            async with aiohttp.ClientSession(headers=headers, connector=conn) as session:
                if cookies_bool:
                    async with session.get(url, timeout=async_timeout, cookies=cookies) as response:
                        rex_text = await response.text()
                        if check_value and check_value not in rex_text:
                            raise Exception(f"check_value 不存在== {check_value}")
                        return rex_text
                else:
                    async with session.get(url, timeout=async_timeout) as response:
                        rex_text = await response.text()
                        if check_value and check_value not in rex_text:
                            raise Exception(f"check_value 不存在== {check_value}")
                        return rex_text
        except asyncio.TimeoutError as e:
            retries += 1
            logger.error(f'error== 请求超时错误 timeout={timeout}：Retry {retries} for {url} -- {e}')
        except aiohttp.ClientError as e:
            retries += 1
            logger.error(f'error== 客户端请求错误 timeout={timeout}：Retry {retries} for {url} -- {e}')
        except Exception as e:
            retries += 1
            logger.error(f'error== 请求未知错误 timeout={timeout}：Retry {retries} for {url} -- {e}')
    return None


async def download_image(url, image_timeout):
    image_data = None
    if url.startswith("http"):
        retries = 0
        try:
            conn = aiohttp.TCPConnector(ssl=False)
            async_timeout = aiohttp.ClientTimeout(total=image_timeout)
            async with aiohttp.ClientSession(connector=conn) as session:
                async with session.get(url, timeout=async_timeout) as response:
                    status_code = response.status
                    if status_code != 200:
                        raise Exception(f"status_code is {status_code}")
                    image_data = await response.read()
                    return url, image_data, 0
        except asyncio.TimeoutError as e:
            retries += 1
            logger.error(f'error==图片 请求超时错误 timeout={image_timeout}：Retry {retries} for {url} -- {e}')
        except aiohttp.ClientError as e:
            retries += 1
            logger.error(f'error==图片 客户端请求错误 timeout={image_timeout}：Retry {retries} for {url} -- {e}')
        except Exception as e:
            retries += 1
            logger.error(f'error==图片 请求未知错误 timeout={image_timeout}：Retry {retries} for {url} -- {e}')
        finally:
            return url, image_data, 0
    else:
        return url, image_data, 0


async def upload_image(url_list, timeout):
    img_item = {}
    error_count = 0
    tasks = [download_image(url, timeout) for url in url_list]
    image_datas = await asyncio.gather(*tasks)
    for url, image_data, status in image_datas:
        if status == 1:
            img_item[url] = image_data
        elif image_data:
            file_name = generate_md5(url) + ".png"
            # 这个需要自己配置oss地址
            auth = oss2.Auth(oss_key, oss_value)
            bucket = oss2.Bucket(auth, 'oss-cn-hangzhou-internal.aliyuncs.com', 'lianqiai-public')
            result = bucket.put_object('upload/bing_logo/' + file_name, image_data)
            if result.status == 200:
                oss_url = f'https://lianqiai-public.oss-cn-hangzhou.aliyuncs.com/upload/bing_logo/{file_name}'
                try:
                    image = Image.open(BytesIO(image_data), 'r')
                    width, height = list(image.size)
                    img_item[url] = {
                        'oss_url': oss_url,
                        'width': width,
                        'height': height,
                    }
                except Exception as e:
                    img_item[url] = {
                        'oss_url': None,
                        'width': None,
                        'height': None,
                    }
            else:
                error_count += 1
                img_item[url] = {
                    'oss_url': None,
                    'width': None,
                    'height': None,
                }
                logger.error(f"文件上传失败 {result.status} {result.resp.body}")
        else:
            error_count += 1
            img_item[url] = {
                'oss_url': None,
                'width': None,
                'height': None,
            }
    return img_item, error_count


# 使用redis-代理池
# def get_redis_proxies(retry=0):
#     try:
#         conn = redis.Redis(host=redis_host, port=6379, db=9)
#         key_list = conn.keys()
#         conn.close()
#         if len(key_list) != 0:
#             proxies = random.choice(key_list).decode()
#             return proxies
#         else:
#             raise Exception('代理获取为空')
#     except Exception as e:
#         retry += 1
#         if retry < 3:
#             return get_redis_proxies(retry=retry)
#         else:
#             fs_send_msg("error", "redis-proxies", f"db 9获取 redis为空 {e}")
#             return None


# 使用普通代理
def get_redis_proxies(retry=0):
    try:
        proxies = None
        return proxies
    except Exception as e:
        retry += 1
        if retry < 3:
            return get_redis_proxies(retry=retry)
        else:
            fs_send_msg("error", "redis-proxies", f"db 9获取 redis为空 {e}")
            return None


if __name__ == '__main__':
    res_json = {
        "status": 200,
        "message": "查询成功",
        "time": "3.65",
        "count": 0,
        "error_count": 0,
        "data": []
    }

    contents = [
        ('log_type', "info"),
        ('time', "1"),
        ('query', '月亮弯弯'),
        ('api_type', 'bing_list'),
        ('msg', '查询日常'),
        ('remark', 'level'),
        ('response', json.dumps(res_json, ensure_ascii=False)),

    ]
    put_logs(contents)
